// Raytracer.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <CommCtrl.h>
#include "Raytracer.h"
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "cximagecrtd.lib") // Dolaczamy biblioteke gdiplus
#include "ximage.h"
#include "scene.h"
//using namespace std;
#define Z_PLIKU 0

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
Scene thescene;
HWND hWnd;
HWND hWndProgress;
CxImage imageDest;
HDC hdc;
PAINTSTRUCT ps;
// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
VOID InitRaytracer();

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_RAYTRACER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_RAYTRACER));
	
	
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_RAYTRACER));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_RAYTRACER);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(icc);
	icc.dwICC = ICC_PROGRESS_CLASS;
   InitCommonControlsEx(&icc);	
   
   if (!hWnd)
   {
      return FALSE;
   }
	InitRaytracer();
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);


   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;


	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		imageDest.Draw(hdc);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
VOID InitRaytracer()
{
	int width = 800;
	int height = 600;
	SendMessage(hWndProgress, PBM_SETRANGE, 0, (LPARAM)MAKELONG(0, height));
	imageDest.Create(	width,
		height,
		32,
		CXIMAGE_FORMAT_BMP);
		thescene.SetFile("script0.bmp");


		PointLight *pt = new PointLight(Color(0.5f, 0, 0), Vector(0, 300, 500));
		thescene.AddLight(pt);
		pt = new PointLight(Color(0, 0.4f, 0), Vector(-200, 200, -200));
		thescene.AddLight(pt);
		pt = new PointLight(Color(0, 0, 0.8f), Vector(0, 300, -200));
		thescene.AddLight(pt);
		pt = new PointLight(Color(0.8f, 0.8f, 0), Vector(0, 0, 500));
		thescene.AddLight(pt);

		Sphere *sph;
		sph = new Sphere(200, 20, 850, 30, Color(0.3, 0.0, 0.4));
		thescene.AddObj(sph);

		sph = new Sphere(220, 80, 650, 30, Color(0.7, 0.0, 0.4));
		thescene.AddObj(sph);

		sph = new Sphere(280, 100, 450, 30, Color(0.3, 0.7, 0.4));
		thescene.AddObj(sph);

		sph = new Sphere(300, 190, 250, 30, Color(0.3, 0.2, 0.7));
		thescene.AddObj(sph);

		sph = new Sphere(0, 0, 800, 150, Color(0.7, 0.3, 0.1));
		thescene.AddObj(sph);

		sph = new Sphere(-300, -300, 600, 400, Color(0.1, 0.0, 0.4));
		thescene.AddObj(sph);

		Plane *pla = new Plane(0, 1, 0, 4000, Color(0.6, 0.3, 0.1));
		thescene.AddObj(pla);

		thescene.SetFOV(90);
		thescene.SetH(width);
		thescene.SetV(height);
		thescene.SetAspect(1);
		thescene.Trace();
		
		imageDest.Save("render.bmp",CXIMAGE_FORMAT_BMP);
}

